<template>
  <v-container class="pa-0">
    <FlightsCasePaxImport v-if="flight" :flight="flight" @dataNotSaved="canLeave = !$event" />

    <LazyModificationsConfirmDialog v-model="showDialog" @confirm="discardChanges" @close="closeDialog" />
  </v-container>
</template>

<script setup lang="ts">
import { Flight } from "~/dto/flight.dto";

defineProps<{ flight: Flight }>();

const showDialog = ref(false);
const toRedirect: Ref<any> = ref(null);
const canLeave = ref(true);

onBeforeRouteLeave((to, from, next) => {
  if (toRedirect.value || canLeave.value) {
    next();
  } else {
    toRedirect.value = to;
    showDialog.value = true;
  }
});

const closeDialog = () => {
  showDialog.value = false;
  toRedirect.value = null;
};

const discardChanges = () => {
  showDialog.value = false;

  if (toRedirect.value) {
    navigateTo(toRedirect.value!);
  }
};

</script>

